Index: src/ResolvExpr/CommonType.cc
===================================================================
--- src/ResolvExpr/CommonType.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/CommonType.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -713,5 +713,5 @@
 			const ast::Type * base = oPtr->base;
 			if ( auto var = dynamic_cast< const ast::TypeInstType * >( base ) ) {
-				auto entry = open.find( *var );
+				auto entry = open.find( var->name );
 				if ( entry != open.end() ) {
 					ast::AssertionSet need, have;
Index: src/ResolvExpr/ConversionCost.cc
===================================================================
--- src/ResolvExpr/ConversionCost.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/ConversionCost.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -498,5 +498,5 @@
 ) {
 	if ( const ast::TypeInstType * inst = dynamic_cast< const ast::TypeInstType * >( dst ) ) {
-		if ( const ast::EqvClass * eqv = env.lookup( *inst ) ) {
+		if ( const ast::EqvClass * eqv = env.lookup( inst->name ) ) {
 			if ( eqv->bound ) {
 				return conversionCost(src, eqv->bound, srcIsLvalue, symtab, env );
@@ -675,9 +675,9 @@
 
 void ConversionCost_new::postvisit( const ast::TypeInstType * typeInstType ) {
-	if ( const ast::EqvClass * eqv = env.lookup( *typeInstType ) ) {
+	if ( const ast::EqvClass * eqv = env.lookup( typeInstType->name ) ) {
 		cost = costCalc( eqv->bound, dst, srcIsLvalue, symtab, env );
 	} else if ( const ast::TypeInstType * dstAsInst =
 			dynamic_cast< const ast::TypeInstType * >( dst ) ) {
-		if ( *typeInstType == *dstAsInst ) {
+		if ( typeInstType->name == dstAsInst->name ) {
 			cost = Cost::zero;
 		}
Index: src/ResolvExpr/FindOpenVars.cc
===================================================================
--- src/ResolvExpr/FindOpenVars.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/FindOpenVars.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -112,16 +112,16 @@
 				// mark open/closed variables
 				if ( nextIsOpen ) {
-					for ( auto & decl : type->forall ) {
-						open[ *decl ] = ast::TypeDecl::Data{ decl->base };
-					}
-					for ( auto & assert : type->assertions ) {
-						need[ assert ].isUsed = false;
+					for ( const ast::TypeDecl * decl : type->forall ) {
+						open[ decl->name ] = ast::TypeDecl::Data{ decl };
+						for ( const ast::DeclWithType * assert : decl->assertions ) {
+							need[ assert ].isUsed = false;
+						}
 					}
 				} else {
-					for ( auto & decl : type->forall ) {
-						closed[ *decl ] = ast::TypeDecl::Data{ decl->base };	
-					}
-					for ( auto & assert : type->assertions ) {
-						have[ assert ].isUsed = false;
+					for ( const ast::TypeDecl * decl : type->forall ) {
+						closed[ decl->name ] = ast::TypeDecl::Data{ decl };
+						for ( const ast::DeclWithType * assert : decl->assertions ) {
+							have[ assert ].isUsed = false;
+						}
 					}
 				}
Index: src/ResolvExpr/PolyCost.cc
===================================================================
--- src/ResolvExpr/PolyCost.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/PolyCost.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -68,5 +68,5 @@
 
 	void previsit( const ast::TypeInstType * type ) {
-		if ( const ast::EqvClass * eqv = env_.lookup( *type ) ) /* && */ if ( eqv->bound ) {
+		if ( const ast::EqvClass * eqv = env_.lookup( type->name ) ) /* && */ if ( eqv->bound ) {
 			if ( const ast::TypeInstType * otherType = eqv->bound.as< ast::TypeInstType >() ) {
 				if ( symtab.lookupType( otherType->name ) ) {
Index: src/ResolvExpr/PtrsAssignable.cc
===================================================================
--- src/ResolvExpr/PtrsAssignable.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/PtrsAssignable.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -134,5 +134,5 @@
 	}
 	void postvisit( const ast::TypeInstType * inst ) {
-		if ( const ast::EqvClass * eqv = typeEnv.lookup( *inst ) ) {
+		if ( const ast::EqvClass * eqv = typeEnv.lookup( inst->name ) ) {
 			if ( eqv->bound ) {
 				// T * = S * for any S depends on the type bound to T
@@ -146,5 +146,5 @@
 		const ast::TypeEnvironment & env ) {
 	if ( const ast::TypeInstType * dstAsInst = dynamic_cast< const ast::TypeInstType * >( dst ) ) {
-		if ( const ast::EqvClass * eqv = env.lookup( *dstAsInst ) ) {
+		if ( const ast::EqvClass * eqv = env.lookup( dstAsInst->name ) ) {
 			return ptrsAssignable( src, eqv->bound, env );
 		}
Index: src/ResolvExpr/PtrsCastable.cc
===================================================================
--- src/ResolvExpr/PtrsCastable.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/PtrsCastable.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -180,5 +180,5 @@
 					}
 				}
-			} else if ( const ast::EqvClass * eqvClass = env.lookup( *inst ) ) {
+			} else if ( const ast::EqvClass * eqvClass = env.lookup( inst->name ) ) {
 				if ( eqvClass->data.kind == ast::TypeDecl::Ftype ) {
 					return -1;
@@ -283,5 +283,5 @@
 ) {
 	if ( auto inst = dynamic_cast< const ast::TypeInstType * >( dst ) ) {
-		if ( const ast::EqvClass * eqvClass = env.lookup( *inst ) ) {
+		if ( const ast::EqvClass * eqvClass = env.lookup( inst->name ) ) {
 			return ptrsAssignable( src, eqvClass->bound, env );
 		}
Index: src/ResolvExpr/RenameVars.cc
===================================================================
--- src/ResolvExpr/RenameVars.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/RenameVars.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -19,4 +19,5 @@
 #include <utility>                 // for pair
 
+#include "AST/ForallSubstitutionTable.hpp"
 #include "AST/Pass.hpp"
 #include "AST/Type.hpp"
@@ -38,10 +39,8 @@
 		int level = 0;
 		int resetCount = 0;
+		ScopedMap< std::string, std::string > nameMap;
+	public:
+		ast::ForallSubstitutionTable subs;
 
-		int next_expr_id = 1;
-		int next_usage_id = 1;
-		ScopedMap< std::string, std::string > nameMap;
-		ScopedMap< std::string, ast::TypeInstType::TypeEnvKey > idMap;
-	public:
 		void reset() {
 			level = 0;
@@ -54,8 +53,4 @@
 				type->name = it->second;
 			}
-		}
-
-		void nextUsage() {
-			++next_usage_id;
 		}
 
@@ -83,13 +78,13 @@
 
 		const ast::TypeInstType * rename( const ast::TypeInstType * type ) {
+			// re-linking of base type handled by WithForallSubstitutor
+
 			// rename
-			auto it = idMap.find( type->name );
-			if ( it != idMap.end() ) {
-				// unconditionally mutate because map will *always* have different name
-				ast::TypeInstType * mut = ast::shallowCopy( type );
-				// reconcile base node since some copies might have been made
-				mut->base = it->second.base;
-				mut->formal_usage = it->second.formal_usage;
-				mut->expr_id = it->second.expr_id;
+			auto it = nameMap.find( type->name );
+			if ( it != nameMap.end() ) {
+				// unconditionally mutate because map will *always* have different name,
+				// if this mutates, will *always* have been mutated by ForallSubstitutor above
+				ast::TypeInstType * mut = ast::mutate( type );
+				mut->name = it->second;
 	            type = mut;
 			}
@@ -98,38 +93,34 @@
 		}
 
-		const ast::FunctionType * openLevel( const ast::FunctionType * type, RenameMode mode ) {
+		const ast::FunctionType * openLevel( const ast::FunctionType * type ) {
 			if ( type->forall.empty() ) return type;
-			idMap.beginScope();
+
+			nameMap.beginScope();
 
 			// Load new names from this forall clause and perform renaming.
-			auto mutType = ast::shallowCopy( type );
-			// assert( type == mutType && "mutated type must be unique from ForallSubstitutor" );
-			for ( auto & td : mutType->forall ) {
-				auto mut = ast::shallowCopy( td.get() );
-				// assert( td == mutDecl && "mutated decl must be unique from ForallSubstitutor" );
+			auto mutType = ast::mutate( type );
+			assert( type == mutType && "mutated type must be unique from ForallSubstitutor" );
+			for ( ast::ptr< ast::TypeDecl > & td : mutType->forall ) {
+				assertf(dynamic_cast<ast::FunctionType *>(mutType), "renaming vars in non-function type");
+				std::ostringstream output;
+				output << "_" << resetCount << "_" << level << "_" << td->name;
+				std::string newname =  output.str();
+				nameMap[ td->name ] = newname;
+				++level;
 
-				if (mode == GEN_EXPR_ID) {
-					mut->expr_id = next_expr_id;
-					mut->formal_usage = -1;
-					++next_expr_id;
-				}
-				else if (mode == GEN_USAGE) {
-					assertf(mut->expr_id, "unfilled expression id in generating candidate type");
-					mut->formal_usage = next_usage_id;
-				}
-				else {
-					assert(false);
-				}
-				idMap[ td->name ] = ast::TypeInstType::TypeEnvKey(*mut);
-				
-				td = mut;
+				ast::TypeDecl * mutDecl = ast::mutate( td.get() );
+				assert( td == mutDecl && "mutated decl must be unique from ForallSubstitutor" );
+				mutDecl->name = newname;
+				// assertion above means `td = mutDecl;` is unnecessary
 			}
+			// assertion above means `type = mutType;` is unnecessary
 
-			return mutType;
+			return type;
 		}
 
 		void closeLevel( const ast::FunctionType * type ) {
 			if ( type->forall.empty() ) return;
-			idMap.endScope();
+
+			nameMap.endScope();
 		}
 	};
@@ -151,9 +142,10 @@
 	};
 
-	struct RenameVars_new : public ast::PureVisitor /*: public ast::WithForallSubstitutor*/ {
-		RenameMode mode;
+	struct RenameVars_new /*: public ast::WithForallSubstitutor*/ {
+		#warning when old RenameVars goes away, replace hack below with global pass inheriting from WithForallSubstitutor
+		ast::ForallSubstitutionTable & subs = renaming.subs;
 
 		const ast::FunctionType * previsit( const ast::FunctionType * type ) {
-			return renaming.openLevel( type, mode );
+			return renaming.openLevel( type );
 		}
 
@@ -171,5 +163,4 @@
 
 		const ast::TypeInstType * previsit( const ast::TypeInstType * type ) {
-			if (mode == GEN_USAGE && !type->formal_usage) return type; // do not rename an actual type
 			return renaming.rename( type );
 		}
@@ -186,17 +177,13 @@
 }
 
-const ast::Type * renameTyVars( const ast::Type * t, RenameMode mode, bool reset ) {
-	// ast::Type *tc = ast::deepCopy(t);
+const ast::Type * renameTyVars( const ast::Type * t ) {
+	ast::Type *tc = ast::deepCopy(t);
 	ast::Pass<RenameVars_new> renamer;
-	renamer.core.mode = mode;
-	if (mode == GEN_USAGE && reset) {
-		renaming.nextUsage();
-	}
-	return t->accept( renamer );
+//	return t->accept( renamer );
+	return tc->accept( renamer );
 }
 
 void resetTyVarRenaming() {
 	renaming.reset();
-	renaming.nextUsage();
 }
 
Index: src/ResolvExpr/RenameVars.h
===================================================================
--- src/ResolvExpr/RenameVars.h	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/RenameVars.h	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -30,16 +30,8 @@
 	/// Provides a consistent renaming of forall type names in a hierarchy by prefixing them with a unique "level" ID
 	void renameTyVars( Type * );
-
-	enum RenameMode {
-		GEN_USAGE, // for type in VariableExpr
-		GEN_EXPR_ID // for type in decl
-	};
-	const ast::Type * renameTyVars( const ast::Type *, RenameMode mode = GEN_USAGE, bool reset = true );
-	
+	const ast::Type * renameTyVars( const ast::Type * );
 
 	/// resets internal state of renamer to avoid overflow
 	void resetTyVarRenaming();
-
-	
 } // namespace ResolvExpr
 
Index: src/ResolvExpr/ResolvMode.h
===================================================================
--- src/ResolvExpr/ResolvMode.h	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/ResolvMode.h	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -23,7 +23,9 @@
 		const bool failFast;         ///< Fail on no resulting alternatives? [true]
 
+	private:
 		constexpr ResolvMode(bool a, bool p, bool ff) 
 		: adjust(a), prune(p), failFast(ff) {}
 
+	public:
 		/// Default settings
 		constexpr ResolvMode() : adjust(false), prune(true), failFast(true) {}
Index: src/ResolvExpr/ResolveAssertions.cc
===================================================================
--- src/ResolvExpr/ResolveAssertions.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/ResolveAssertions.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -397,5 +397,5 @@
 
 	/// Limit to depth of recursion of assertion satisfaction
-	static const int recursionLimit = 7;
+	static const int recursionLimit = 4;
 	/// Maximum number of simultaneously-deferred assertions to attempt concurrent satisfaction of
 	static const int deferLimit = 10;
Index: src/ResolvExpr/ResolveTypeof.cc
===================================================================
--- src/ResolvExpr/ResolveTypeof.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/ResolveTypeof.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -15,5 +15,4 @@
 
 #include "ResolveTypeof.h"
-#include "RenameVars.h"
 
 #include <cassert>               // for assert
@@ -219,5 +218,4 @@
 			mutDecl->mangleName = Mangle::mangle(mutDecl); // do not mangle unnamed variables
 		
-		mutDecl->type = renameTyVars(mutDecl->type, RenameMode::GEN_EXPR_ID);
 		mutDecl->isTypeFixed = true;
 		return mutDecl;
Index: src/ResolvExpr/Resolver.cc
===================================================================
--- src/ResolvExpr/Resolver.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/Resolver.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -986,4 +986,5 @@
 		};
 	} // anonymous namespace
+
 	/// Check if this expression is or includes a deleted expression
 	const ast::DeletedExpr * findDeletedExpr( const ast::Expr * expr ) {
@@ -1151,4 +1152,5 @@
 			const ast::Expr * untyped, const ast::SymbolTable & symtab
 		) {
+			resetTyVarRenaming();
 			ast::TypeEnvironment env;
 			ast::ptr< ast::Expr > newExpr = resolveInVoidContext( untyped, symtab, env );
@@ -1310,11 +1312,12 @@
 	}
 
-	const ast::Expr * resolveStmtExpr(
+	ast::ptr< ast::Expr > resolveStmtExpr(
 		const ast::StmtExpr * stmtExpr, const ast::SymbolTable & symtab
 	) {
 		assert( stmtExpr );
 		ast::Pass< Resolver_new > resolver{ symtab };
-		auto ret = mutate(stmtExpr->accept(resolver));
-		strict_dynamic_cast< ast::StmtExpr * >( ret )->computeResult();
+		ast::ptr< ast::Expr > ret = stmtExpr;
+		ret = ret->accept( resolver );
+		strict_dynamic_cast< ast::StmtExpr * >( ret.get_and_mutate() )->computeResult();
 		return ret;
 	}
@@ -1372,17 +1375,15 @@
 			}
 
-			// handle assertions
+			// handle assertions. (seems deep)
 
 			symtab.enterScope();
-			mutType->forall.clear();
-			mutType->assertions.clear();
-			for (auto & typeParam : mutDecl->type_params) {
-				symtab.addType(typeParam);
-				mutType->forall.emplace_back(new ast::TypeInstType(typeParam->name, typeParam));
-			}
-			for (auto & asst : mutDecl->assertions) {
-				asst = fixObjectType(asst.strict_as<ast::ObjectDecl>(), symtab);
-				symtab.addId(asst);
-				mutType->assertions.emplace_back(new ast::VariableExpr(functionDecl->location, asst));
+			for (auto & typeParam : mutType->forall) {
+				auto mutParam = typeParam.get_and_mutate();
+				symtab.addType(mutParam);
+				for (auto & asst : mutParam->assertions) {
+					asst = fixObjectType(asst.strict_as<ast::ObjectDecl>(), symtab);
+					symtab.addId(asst);
+				}
+				typeParam = mutParam;
 			}
 
@@ -1406,6 +1407,4 @@
 			mutType->returns = std::move(returnTypes);
 
-			auto renamedType = strict_dynamic_cast<const ast::FunctionType *>(renameTyVars(mutType, RenameMode::GEN_EXPR_ID));
-
 			std::list<ast::ptr<ast::Stmt>> newStmts;
 			resolveWithExprs (mutDecl->withExprs, newStmts);
@@ -1419,5 +1418,4 @@
 			symtab.leaveScope();
 
-			mutDecl->type = renamedType;
 			mutDecl->mangleName = Mangle::mangle(mutDecl);
 			mutDecl->isTypeFixed = true;
@@ -1536,5 +1534,6 @@
 	const PtrType * handlePtrType( const PtrType * type, const ast::SymbolTable & symtab ) {
 		if ( type->dimension ) {
-			ast::ptr< ast::Type > sizeType = ast::sizeType;
+			#warning should use new equivalent to Validate::SizeType rather than sizeType here
+			ast::ptr< ast::Type > sizeType = new ast::BasicType{ ast::BasicType::LongUnsignedInt };
 			ast::mutate_field(
 				type, &PtrType::dimension,
Index: src/ResolvExpr/Resolver.h
===================================================================
--- src/ResolvExpr/Resolver.h	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/Resolver.h	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -72,6 +72,6 @@
 	ast::ptr< ast::Init > resolveCtorInit(
 		const ast::ConstructorInit * ctorInit, const ast::SymbolTable & symtab );
-	/// Resolves a statement expression 
-	const ast::Expr * resolveStmtExpr(
+	/// Resolves a statement expression
+	ast::ptr< ast::Expr > resolveStmtExpr(
 		const ast::StmtExpr * stmtExpr, const ast::SymbolTable & symtab );
 } // namespace ResolvExpr
Index: src/ResolvExpr/SatisfyAssertions.cpp
===================================================================
--- src/ResolvExpr/SatisfyAssertions.cpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/SatisfyAssertions.cpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -57,8 +57,8 @@
 		ast::UniqueId resnSlot;          ///< Slot for any recursive assertion IDs
 
-		AssnCandidate(
-			const ast::SymbolTable::IdData c, const ast::Type * at, ast::TypeEnvironment && e,
+		AssnCandidate( 
+			const ast::SymbolTable::IdData c, const ast::Type * at, ast::TypeEnvironment && e, 
 			ast::AssertionSet && h, ast::AssertionSet && n, ast::OpenVarSet && o, ast::UniqueId rs )
-		: cdata( c ), adjType( at ), env( std::move( e ) ), have( std::move( h ) ),
+		: cdata( c ), adjType( at ), env( std::move( e ) ), have( std::move( h ) ), 
 		  need( std::move( n ) ), open( std::move( o ) ), resnSlot( rs ) {}
 	};
@@ -69,19 +69,19 @@
 	/// Reference to a single deferred item
 	struct DeferRef {
-		const ast::VariableExpr * expr;
+		const ast::DeclWithType * decl;
 		const ast::AssertionSetValue & info;
 		const AssnCandidate & match;
 	};
-
-	/// Wrapper for the deferred items from a single assertion satisfaction.
+	
+	/// Wrapper for the deferred items from a single assertion satisfaction. 
 	/// Acts like an indexed list of DeferRef
 	struct DeferItem {
-		const ast::VariableExpr * expr;
+		const ast::DeclWithType * decl;
 		const ast::AssertionSetValue & info;
 		AssnCandidateList matches;
 
-		DeferItem(
-			const ast::VariableExpr * d, const ast::AssertionSetValue & i, AssnCandidateList && ms )
-		: expr( d ), info( i ), matches( std::move( ms ) ) {}
+		DeferItem( 
+			const ast::DeclWithType * d, const ast::AssertionSetValue & i, AssnCandidateList && ms )
+		: decl( d ), info( i ), matches( std::move( ms ) ) {}
 
 		bool empty() const { return matches.empty(); }
@@ -89,5 +89,5 @@
 		AssnCandidateList::size_type size() const { return matches.size(); }
 
-		DeferRef operator[] ( unsigned i ) const { return { expr, info, matches[i] }; }
+		DeferRef operator[] ( unsigned i ) const { return { decl, info, matches[i] }; }
 	};
 
@@ -117,18 +117,18 @@
 		/// Initial satisfaction state for a candidate
 		SatState( CandidateRef & c, const ast::SymbolTable & syms )
-		: cand( c ), need(), newNeed(), deferred(), inferred(), costs{ Cost::zero },
+		: cand( c ), need(), newNeed(), deferred(), inferred(), costs{ Cost::zero }, 
 		  symtab( syms ) { need.swap( c->need ); }
-
+		
 		/// Update satisfaction state for next step after previous state
 		SatState( SatState && o, IterateFlag )
-		: cand( std::move( o.cand ) ), need( o.newNeed.begin(), o.newNeed.end() ), newNeed(),
-		  deferred(), inferred( std::move( o.inferred ) ), costs( std::move( o.costs ) ),
+		: cand( std::move( o.cand ) ), need( o.newNeed.begin(), o.newNeed.end() ), newNeed(), 
+		  deferred(), inferred( std::move( o.inferred ) ), costs( std::move( o.costs ) ), 
 		  symtab( o.symtab ) { costs.emplace_back( Cost::zero ); }
-
+		
 		/// Field-wise next step constructor
 		SatState(
-			CandidateRef && c, ast::AssertionSet && nn, InferCache && i, CostVec && cs,
+			CandidateRef && c, ast::AssertionSet && nn, InferCache && i, CostVec && cs, 
 			ast::SymbolTable && syms )
-		: cand( std::move( c ) ), need( nn.begin(), nn.end() ), newNeed(), deferred(),
+		: cand( std::move( c ) ), need( nn.begin(), nn.end() ), newNeed(), deferred(), 
 		  inferred( std::move( i ) ), costs( std::move( cs ) ), symtab( std::move( syms ) )
 		  { costs.emplace_back( Cost::zero ); }
@@ -138,17 +138,17 @@
 	void addToSymbolTable( const ast::AssertionSet & have, ast::SymbolTable & symtab ) {
 		for ( auto & i : have ) {
-			if ( i.second.isUsed ) { symtab.addId( i.first->var ); }
+			if ( i.second.isUsed ) { symtab.addId( i.first ); }
 		}
 	}
 
 	/// Binds a single assertion, updating satisfaction state
-	void bindAssertion(
-		const ast::VariableExpr * expr, const ast::AssertionSetValue & info, CandidateRef & cand,
+	void bindAssertion( 
+		const ast::DeclWithType * decl, const ast::AssertionSetValue & info, CandidateRef & cand, 
 		AssnCandidate & match, InferCache & inferred
 	) {
 		const ast::DeclWithType * candidate = match.cdata.id;
-		assertf( candidate->uniqueId,
+		assertf( candidate->uniqueId, 
 			"Assertion candidate does not have a unique ID: %s", toString( candidate ).c_str() );
-
+		
 		ast::Expr * varExpr = match.cdata.combine( cand->expr->location, cand->cvtCost );
 		varExpr->result = match.adjType;
@@ -156,6 +156,6 @@
 
 		// place newly-inferred assertion in proper location in cache
-		inferred[ info.resnSlot ][ expr->var->uniqueId ] = ast::ParamEntry{
-			candidate->uniqueId, candidate, match.adjType, expr->result, varExpr };
+		inferred[ info.resnSlot ][ decl->uniqueId ] = ast::ParamEntry{
+			candidate->uniqueId, candidate, match.adjType, decl->get_type(), varExpr };
 	}
 
@@ -169,8 +169,8 @@
 
 		std::vector<ast::SymbolTable::IdData> candidates;
-		auto kind = ast::SymbolTable::getSpecialFunctionKind(assn.first->var->name);
+		auto kind = ast::SymbolTable::getSpecialFunctionKind(assn.first->name);
 		if (kind != ast::SymbolTable::SpecialFunctionKind::NUMBER_OF_KINDS) {
 			// prefilter special decls by argument type, if already known
-			ast::ptr<ast::Type> thisArgType = assn.first->result.strict_as<ast::PointerType>()->base
+			ast::ptr<ast::Type> thisArgType = strict_dynamic_cast<const ast::PointerType *>(assn.first->get_type())->base
 				.strict_as<ast::FunctionType>()->params[0]
 				.strict_as<ast::ReferenceType>()->base;
@@ -184,5 +184,5 @@
 		}
 		else {
-			candidates = sat.symtab.lookupId(assn.first->var->name);
+			candidates = sat.symtab.lookupId(assn.first->name);
 		}
 		for ( const ast::SymbolTable::IdData & cdata : candidates ) {
@@ -200,7 +200,7 @@
 			ast::TypeEnvironment newEnv{ sat.cand->env };
 			ast::OpenVarSet newOpen{ sat.cand->open };
-			ast::ptr< ast::Type > toType = assn.first->result;
-			ast::ptr< ast::Type > adjType =
-				renameTyVars( adjustExprType( candidate->get_type(), newEnv, sat.symtab ), GEN_USAGE, false );
+			ast::ptr< ast::Type > toType = assn.first->get_type();
+			ast::ptr< ast::Type > adjType = 
+				renameTyVars( adjustExprType( candidate->get_type(), newEnv, sat.symtab ) );
 
 			// only keep candidates which unify
@@ -213,5 +213,5 @@
 				}
 
-				matches.emplace_back(
+				matches.emplace_back( 
 					cdata, adjType, std::move( newEnv ), std::move( have ), std::move( newNeed ),
 					std::move( newOpen ), crntResnSlot );
@@ -287,9 +287,9 @@
 	};
 
-	/// Replace ResnSlots with InferParams and add alternative to output list, if it meets pruning
+	/// Replace ResnSlots with InferParams and add alternative to output list, if it meets pruning 
 	/// threshold.
-	void finalizeAssertions(
-		CandidateRef & cand, InferCache & inferred, PruneMap & thresholds, CostVec && costs,
-		CandidateList & out
+	void finalizeAssertions( 
+		CandidateRef & cand, InferCache & inferred, PruneMap & thresholds, CostVec && costs, 
+		CandidateList & out 
 	) {
 		// prune if cheaper alternative for same key has already been generated
@@ -308,6 +308,6 @@
 	}
 
-	/// Combo iterator that combines candidates into an output list, merging their environments.
-	/// Rejects an appended candidate if environments cannot be merged. See `Common/FilterCombos.h`
+	/// Combo iterator that combines candidates into an output list, merging their environments. 
+	/// Rejects an appended candidate if environments cannot be merged. See `Common/FilterCombos.h` 
 	/// for description of "combo iterator".
 	class CandidateEnvMerger {
@@ -337,5 +337,5 @@
 					// compute conversion cost from satisfying decl to assertion
 					cost += computeConversionCost(
-						assn.match.adjType, assn.expr->result, false, symtab, env );
+						assn.match.adjType, assn.decl->get_type(), false, symtab, env );
 
 					// mark vars+specialization on function-type assertions
@@ -350,5 +350,7 @@
 					cost.incVar( func->forall.size() );
 
-					cost.decSpec( func->assertions.size() );
+					for ( const ast::TypeDecl * td : func->forall ) {
+						cost.decSpec( td->assertions.size() );
+					}
 				}
 			}
@@ -385,11 +387,11 @@
 
 	/// Limit to depth of recursion of assertion satisfaction
-	static const int recursionLimit = 8;
+	static const int recursionLimit = 4;
 	/// Maximum number of simultaneously-deferred assertions to attempt concurrent satisfaction of
 	static const int deferLimit = 10;
 } // anonymous namespace
 
-void satisfyAssertions(
-	CandidateRef & cand, const ast::SymbolTable & symtab, CandidateList & out,
+void satisfyAssertions( 
+	CandidateRef & cand, const ast::SymbolTable & symtab, CandidateList & out, 
 	std::vector<std::string> & errors
 ) {
@@ -417,20 +419,8 @@
 			if ( it != thresholds.end() && it->second < sat.costs ) goto nextSat;
 
-			// should a limit be imposed? worst case here is O(n^2) but very unlikely to happen.
-			for (unsigned resetCount = 0; ; ++resetCount) {
-				ast::AssertionList next;
-				resetTyVarRenaming();
-				// make initial pass at matching assertions
-				for ( auto & assn : sat.need ) {
-					// fail early if any assertion is not satisfiable
-					if ( ! satisfyAssertion( assn, sat ) ) {
-						next.emplace_back(assn);
-						// goto nextSat;
-					}
-				}
-				// success
-				if (next.empty()) break;
-				// fail if nothing resolves
-				else if (next.size() == sat.need.size()) {
+			// make initial pass at matching assertions
+			for ( auto & assn : sat.need ) {
+				// fail early if any assertion is not satisfiable
+				if ( ! satisfyAssertion( assn, sat ) ) {
 					Indenter tabs{ 3 };
 					std::ostringstream ss;
@@ -438,10 +428,9 @@
 					print( ss, *sat.cand, ++tabs );
 					ss << (tabs-1) << "Could not satisfy assertion:\n";
-					ast::print( ss, next[0].first, tabs );
+					ast::print( ss, assn.first, tabs );
 
 					errors.emplace_back( ss.str() );
 					goto nextSat;
 				}
-				sat.need = std::move(next);
 			}
 
@@ -449,5 +438,5 @@
 				// either add successful match or push back next state
 				if ( sat.newNeed.empty() ) {
-					finalizeAssertions(
+					finalizeAssertions( 
 						sat.cand, sat.inferred, thresholds, std::move( sat.costs ), out );
 				} else {
@@ -462,5 +451,5 @@
 				ss << (tabs-1) << "Too many non-unique satisfying assignments for assertions:\n";
 				for ( const auto & d : sat.deferred ) {
-					ast::print( ss, d.expr, tabs );
+					ast::print( ss, d.decl, tabs );
 				}
 
@@ -471,5 +460,5 @@
 				std::vector< CandidateEnvMerger::OutType > compatible = filterCombos(
 					sat.deferred, CandidateEnvMerger{ sat.cand->env, sat.cand->open, sat.symtab } );
-
+				
 				// fail early if no mutually-compatible assertion satisfaction
 				if ( compatible.empty() ) {
@@ -480,5 +469,5 @@
 					ss << (tabs-1) << "No mutually-compatible satisfaction for assertions:\n";
 					for ( const auto& d : sat.deferred ) {
-						ast::print( ss, d.expr, tabs );
+						ast::print( ss, d.decl, tabs );
 					}
 
@@ -494,5 +483,5 @@
 					// set up next satisfaction state
 					CandidateRef nextCand = std::make_shared<Candidate>(
-						sat.cand->expr, std::move( compat.env ), std::move( compat.open ),
+						sat.cand->expr, std::move( compat.env ), std::move( compat.open ), 
 						ast::AssertionSet{} /* need moved into satisfaction state */,
 						sat.cand->cost, sat.cand->cvtCost );
@@ -500,8 +489,8 @@
 					ast::AssertionSet nextNewNeed{ sat.newNeed };
 					InferCache nextInferred{ sat.inferred };
-
+					
 					CostVec nextCosts{ sat.costs };
 					nextCosts.back() += compat.cost;
-
+								
 					ast::SymbolTable nextSymtab{ sat.symtab };
 
@@ -512,15 +501,15 @@
 						nextNewNeed.insert( match.need.begin(), match.need.end() );
 
-						bindAssertion( r.expr, r.info, nextCand, match, nextInferred );
+						bindAssertion( r.decl, r.info, nextCand, match, nextInferred );
 					}
 
 					// either add successful match or push back next state
 					if ( nextNewNeed.empty() ) {
-						finalizeAssertions(
+						finalizeAssertions( 
 							nextCand, nextInferred, thresholds, std::move( nextCosts ), out );
 					} else {
-						nextSats.emplace_back(
-							std::move( nextCand ), std::move( nextNewNeed ),
-							std::move( nextInferred ), std::move( nextCosts ),
+						nextSats.emplace_back( 
+							std::move( nextCand ), std::move( nextNewNeed ), 
+							std::move( nextInferred ), std::move( nextCosts ), 
 							std::move( nextSymtab ) );
 					}
@@ -534,5 +523,5 @@
 		nextSats.clear();
 	}
-
+	
 	// exceeded recursion limit if reaches here
 	if ( out.empty() ) {
